# Foundations of Python Programming

-   [1\. General Introduction](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/GeneralIntro/toctree.html)
-   [2\. Variables, Statements, and Expressions](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/SimplePythonData/toctree.html)
-   [3\. Debugging](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Debugging/toctree.html)
-   [4\. Python Modules](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/PythonModules/toctree.html) (`import`, `from`, `as`)
-   [5\. Turtle](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/PythonTurtle/toctree.html)
-   [6\. Sequences](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Sequences/toctree.html) (`list`, `str`)
-   [7\. Iteration](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Iteration/toctree.html) (`for`, `str`, `range`, `list`, `index`, `[]`, _accumulator pattern_, _nested for loops_)
-   [8\. Conditionals](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Conditionals/toctree.html) (`if`, `else`, `elif`, `bool`, `>`, `==`, `<`, `not`, `and`, `or`, `is`, `!=`, `max`, `min`, `continue`, `break`, _unary selection_, _nested conditionals_)
-   [9\. Transforming Sequences](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/TransformingSequences/toctree.html) (`list`, `str`, `tuple`, `[:]`, _object references_, _mutability_, _aliasing_, _cloning_ with _slice_, _accumulator pattern_)  
-   [10\. Files](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Files/toctree.html) (`open`, `read`, `write`, `with`, _iterate over file lines_, _context variables_)
-   [11\. Dictionaries](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Dictionaries/toctree.html) (`dict`, `.keys()`, `.values()`, `.items()`, `[]`, _copying dictionaries_, _accumulation pattern_, _hash map_ or _hash table_)
-   [12\. Functions](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Functions/toctree.html) (`def`, `return`, `()`, `global`, `locals()`, `globals()`, _calling a function_, _function definition_, _arguments_ or _parameters_, _keyword arguments_, _named arguments_ or _named parameters_, _positional arguments_, _local namespace_, _global namespace_)
-   [13\. Tuple Packing and Unpacking](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Tuples/toctree.html) (`tuple`, `enumerate`, _enumerate sequence items_, _packing_, _unpacking_, _swapping values_, _returning tuples_)
-   [14\. More About Iteration](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/MoreAboutIteration/toctree.html) (`while`, `break`, `continue`, _listener loop pattern_, _sentinel values_, _random walk_, _halting_, _infinite loop_)  
-   [15\. Advanced Functions](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/AdvancedFunctions/toctree.html) (`kwargs`, `lambda`, _keyword paramaters_ (keyword arguments), _anonymous functions_, _python style_ (PEP8), _methods_)
-   [16\. Sorting](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Sorting/toctree.html) (`sort`, `sorted`, `reversed`, `dict`, _sorting a dict_)  
-   [17\. Nested Data and Nested Iteration](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/NestedData/toctree.html) (`json`, `itertools`, `_dict_`, _nested iteration_, _nested data_, _data structures_, _JSON_, `list`, _nested dictionaries_, _walking nested data_)  
-   [18\. Test Cases](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/TestCases/toctree.html) (_unit tests_, _testing loops_, _testing logic_, _testing functions_, _side effects_, _optional function arguments_ (optional parameters))  
-   [19\. Exceptions](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Exceptions/toctree.html) (`raise`, `try`, `except`, `finaly`, `Exception`, _standard exceptions_ _traceback_)  
-   [20\. Defining your own Classes](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Classes/toctree.html) (`class`, `self`, `__init__`, `__str__`, `str`, `repr`, `__gt__`, _instance methods_, _class methods_, _class attributes_, _class variables_, _instance variabls_, _object oriented programming_, testing classes)  
-   [21\. Building Programs](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/BuildingPrograms/toctree.html)  
-   [22\. Inheritance](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/Inheritance/toctree.html)  
-   [23\. More on Accumulation: Map, Filter, List Comprehension, and Zip](https://runestone.academy/ns/books/published/sdccd_mesa_college_cs179_spring23/AdvancedAccumulation/toctree.html) (`map`, `filter`, `zip`, _list comprehensions_)  
